/*
 * Modify for TB0226.
 * Board initialize code for TANBAC Evaluation board TB0229.
 *
 * (C) Masami Komiya <mkomiya@sonare.it> 2004
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 */

#include <common.h>
#include <command.h>
#include <asm/addrspace.h>
#include <pci.h>
#if defined(CFG_JFFS_CUSTOM_PART)
#include <jffs2/jffs2.h>

static struct part_info part[3];
#endif

unsigned long mips_io_port_base = 0;

#if defined(CONFIG_PCI)
static struct pci_controller hose;

extern void init_vr4131_pci(struct pci_controller*);

void pci_init_board (void)
{
	init_vr4131_pci(&hose);
}
#endif


long int initdram(int board_type)
{
	return get_ram_size ((volatile long *)CFG_SDRAM_BASE, 0x8000000);
}


int checkboard (void)
{
	printf("Board: TANBAC TB0226 ");
	printf("(CPU Speed %d MHz)\n", (int)CPU_CLOCK_RATE/1000000);

	return 0;
}

#if defined(CFG_JFFS_CUSTOM_PART)
struct part_info*
jffs2_part_info(int part_num)
{
        if (0 <= part_num && part_num <=2){
                if(part[part_num].usr_priv==(void*)1)
                        return &part[part_num];
                memset(&part[part_num], 0, sizeof(part[0]));
		switch ( part_num ) {
		case 0:
                	part[part_num].offset=(char*)0xBF000000;
                	part[part_num].size=1024*1024*12;
			break;
		case 1:
                	part[part_num].offset=(char*)0xBFC40000;
                	part[part_num].size=29*128*1024;
			break;
		case 2:
                	part[part_num].offset=(char*)0xBFFE0000;
                	part[part_num].size=112*1024;
			break;
		}
                /* Mark the struct as ready */
                part[part_num].usr_priv=(void*)1;
                return &part;
        }
        return 0;
}
#endif



