/*
 * Modify for TB0226. 2004/09/14 M.Kawamura <kawamura@mlb.co.jp>
 *
 * (C) Copyright 2003
 * Masami Komiya <mkomiya@sonare.it>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * Config header file for TANBAC TB0229 board using an VR4131 CPU module
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#define CONFIG_MIPS32		1	/* MIPS 4Kc CPU core	*/
#define CONFIG_TB0226		1	/* on a TB0226 Board	*/

#ifndef CPU_CLOCK_RATE
#define CPU_CLOCK_RATE	200000000	/* 200 MHz clock for the MIPS core */
#endif
/* #define CPU_TCLOCK_RATE 16588800 */	/* 16.5888 MHz for TClock */
#define CPU_TCLOCK_RATE 24883200	/* 24.8832 MHz for TClock */

#define CONFIG_CONS_INDEX	1
#define CONFIG_BOOTDELAY	5	/* autoboot after 5 seconds	*/

#define CONFIG_BAUDRATE		115200

#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }

#define CONFIG_TIMESTAMP		/* Print image info with timestamp */

#define CONFIG_PREBOOT	"echo \'\n"					\
	"Type \"boot\"		for default way\n"			\
	"Type \"run cram\"		to boot from flash\n"		\
	"Type \"run usb\"		to boot from USB-disk\n"	\
	"Type \"run nfs\"		to boot from NFS\n"		\
	"Type \"run initrd\"	to boot with initrd\n"			\
	"Type \"run nfsinitrd\"	to boot with nfs initrd\n\'"

#undef	CONFIG_BOOTARGS

#define CFG_HUSH_PARSER		1

#ifdef CFG_HUSH_PARSER
#define CONFIG_AUTO_COMPLETE	1
#define CFG_PROMPT_HUSH_PS2  "> "
#define CONFIG_EXTRA_ENV_SETTINGS					\
	"bootargs=root=/dev/mtdblock1\0"				\
	"userargs=setenv bootargs $bootargs console=ttyS0,$baudrate\0"\
	"cramargs=setenv bootargs root=/dev/mtdblock1\0"		\
	"usbargs=setenv bootargs $bootargs usbroot=$usbroot "		\
		"usbtimeout=$usbtimeout ro\0"				\
	"nfsargs=setenv bootargs root=/dev/nfs ip=dhcp nfsroot=$nfsroot ro\0"\
	"cram=run cramargs userargs;fsload uImage&&bootm\0"		\
	"usb=run cramargs usbargs userargs;fsload uImage&&bootm\0"	\
	"nfs=if run load_kernel;then run nfsargs userargs;"		\
		"bootm 80400000;fi\0"					\
	"initrd=run cramargs usbargs userargs;fsload 80400000 uImage&&"	\
		"fsload 80500000 ramImage&&bootm 80400000 80500000\0"	\
	"nfsinitrd=if run load_kernel load_initrd; then "		\
		"run nfsargs usbargs userargs;bootm 80400000 80500000;"	\
		"fi\0"							\
	"usbroot=0/part2\0"						\
	"usbtimeout=5\0"						\
	"autoload=no\0"							\
	"netretry=once\0"						\
	"verify=no\0"							\
	"cram_start=BF000000\0"						\
	"cram_end=BFBFFFFF\0"						\
	"uboot_start=BFC00000\0"					\
	"uboot_end=BFC3FFFF\0"						\
	"opt_start=BFC40000\0"						\
	"opt_end=BFFDFFFF\0"						\
	"conf_start=BFFE0000\0"						\
	"conf_end=BFFFBFFF\0"						\
	"env_start=BFFFC000\0"						\
	"env_end=BFFFFFFF\0"						\
	"cram_file=rom.img\0"						\
	"uboot_file=u-boot.bin\0"					\
	"kernel_file=uImage\0"						\
	"initrd_file=ramImage\0"					\
	"checknfsbase=if test x$nfsbase = x;then "			\
		"echo \"*** ERROR: \'nfsbase\' not set\";test a = b;"	\
		"else test 1 = 1;fi\0"					\
	"checkipaddr=if test x$ipaddr = x;then dhcp;"			\
		"else test 1 = 1;fi\0"					\
	"load_cram=run checknfsbase checkipaddr&&nfs 80400000 $nfsbase$cram_file\0"	\
	"load_uboot=run checknfsbase checkipaddr&&nfs 80400000 $nfsbase$uboot_file\0"\
	"load_kernel=run checknfsbase checkipaddr&&nfs 80400000 $nfsbase$kernel_file" \
		"&&iminfo 80400000\0"					\
	"load_initrd=run checknfsbase checkipaddr&&nfs 80500000 $nfsbase$initrd_file"\
		"&&iminfo 80500000\0"					\
	"init_cram=protect on all;"					\
		"protect off $cram_start $cram_end;"			\
		"echo erasing cram area;"				\
		"erase $cram_start $cram_end\0"				\
	"init_uboot=protect on all;"					\
		"protect off $uboot_start $uboot_end;"			\
		"echo erasing uboot area;"				\
		"erase $uboot_start $uboot_end;\0"			\
	"init_opt=protect on all;"					\
		"protect off $opt_start $opt_end;"			\
		"echo erasing opt area;"				\
		"erase $opt_start $opt_end\0"				\
	"init_conf=protect on all;"					\
		"protect off $conf_start $conf_end;"			\
		"echo erasing conf area;"				\
		"erase $conf_start $conf_end\0"				\
	"init_env=protect on all;"					\
		"protect off $env_start $env_end;"			\
		"echo erasing env area;"				\
		"erase $env_start $env_end\0"				\
	"verify_cram=if run load_cram; then "				\
		"echo verifying image;"					\
		"cmp.b 80400000 $cram_start $filesize&&"		\
		"fsload uImage&&iminfo;"				\
		"fi\0"							\
	"verify_uboot=if run load_uboot; then "				\
		"echo verifying image;"					\
		"cmp.b 80400000 $uboot_start $filesize;"		\
		"else test a = b;fi\0"					\
	"update_cram=if run load_cram; then "				\
		"run init_cram;"					\
		"cp.b 80400000 $cram_start $filesize;"			\
		"run verify_cram;"					\
		"fi\0"							\
	"update_uboot=if run load_uboot; then "				\
		"run init_uboot;"					\
		"cp.b 80400000 $uboot_start $filesize;"			\
		"run verify_uboot && reset;"				\
		"fi\0"							\
	"bootorder=cram usb nfs\0"					\
	"tryboot=for i in $bootorder; do run $i; done\0"		\
	""
#define CONFIG_BOOTCOMMAND	"run tryboot"
#else
#define CONFIG_EXTRA_ENV_SETTINGS					\
	"bootargs=root=/dev/mtdblock1\0"				\
	"userargs=setenv bootargs $(bootargs) console=ttyS0,$(baudrate)\0"\
	"cramargs=setenv bootargs root=/dev/mtdblock1\0"		\
	"usbargs=setenv bootargs $bootargs usbroot=$(usbroot) "		\
		"usbtimeout=$(usbtimeout) ro\0"				\
	"nfsargs=setenv bootargs root=/dev/nfs ip=dhcp nfsroot=$(nfsroot) ro\0"\
	"nfsbase=192.168.3.91:/usr/src/mldbox/\0"			\
	"nfsroot=192.168.3.91:/usr/src/mldbox/rom\0"			\
	"cram=run cramargs userargs;fsload uImage;bootm\0"		\
	"usb=run cramargs usbargs userargs;fsload uImage;bootm\0"	\
	"net=run load_kernel nfsargs userargs; bootm 80400000\0"	\
	"initrd=run cramargs usbargs userargs;fsload 80400000 uImage;"	\
		"fsload 80500000 ramImage;bootm 80400000 80500000\0"	\
	"nfsinitrd=run load_kernel load_initrd nfsargs usbargs userargs;"\
		"bootm 80400000 80500000;\0"				\
	"usbroot=0/part2\0"						\
	"usbtimeout=5\0"						\
	"autoload=no\0"							\
	"netretry=once\0"						\
	"cram_start=BF000000\0"						\
	"cram_end=BFBFFFFF\0"						\
	"uboot_start=BFC00000\0"					\
	"uboot_end=BFC3FFFF\0"						\
	"opt_start=BFC40000\0"						\
	"opt_end=BFFDFFFF\0"						\
	"conf_start=BFFE0000\0"						\
	"conf_end=BFFFBFFF\0"						\
	"env_start=BFFFC000\0"						\
	"env_end=BFFFFFFF\0"						\
	"cram_file=rom.img\0"						\
	"uboot_file=u-boot.bin\0"					\
	"kernel_file=uImage\0"						\
	"initrd_file=ramImage\0"					\
	"load_cram=nfs 80400000 $(nfsbase)$(cram_file)\0"		\
	"load_uboot=nfs 80400000 $(nfsbase)$(uboot_file)\0"		\
	"load_kernel=nfs 80400000 $(nfsbase)$(kernel_file);iminfo 80400000\0"\
	"load_initrd=nfs 80500000 $(nfsbase)$(initrd_file)\0"		\
	"verify_cram=run load_cram;"					\
		"echo verifying;"					\
		"cmp.b 80400000 $(cram_start) $(filesize);"		\
		"fsload uImage; iminfo\0"				\
	"verify_uboot=run load_uboot;"					\
		"echo verifying;"					\
		"cmp.b 80400000 $(uboot_start) $(filesize)\0"		\
	"init_cram=protect off $(cram_start) $(cram_end);"		\
		"echo erasing cram area;"				\
		"erase $(cram_start) $(cram_end)\0"			\
	"init_uboot=protect off $(uboot_start) $(uboot_end);"		\
		"echo erasing uboot area;"				\
		"erase $(uboot_start) $(uboot_end);\0"			\
	"init_opt=protect on all;"					\
		"protect off $(opt_start) $(opt_end);"			\
		"echo erasing opt area;"				\
		"erase $(opt_start) $(opt_end)\0"			\
	"init_conf=protect on all;"					\
		"protect off $(conf_start) $(conf_end);"		\
		"echo erasing conf area;"				\
		"erase $(conf_start) $(conf_end)\0"			\
	"init_env=protect on all;"					\
		"protect off $(env_start) $(env_end);"			\
		"echo erasing env area;"				\
		"erase $(env_start) $(env_end)\0"			\
	"update_cram=protect on all;"					\
		"run load_cram init_cram;"				\
		"cp.b 80400000 $(cram_start) $(filesize);"		\
		"run verify_cram\0"					\
	"update_uboot=protect on all;"					\
		"run load_uboot init_uboot;"				\
		"cp.b 80400000 $(uboot_start) $(filesize);"		\
		"run verify_uboot\0"					\
	""
#define CONFIG_BOOTCOMMAND	"fsload uImage; bootm"
#endif

#define CONFIG_COMMANDS		(CONFIG_CMD_DFL | \
				 CFG_CMD_ASKENV | \
				 CFG_CMD_JFFS2	| \
				 CFG_CMD_DHCP	| \
				 CFG_CMD_PING	| \
				 CFG_CMD_PCI	| \
				 CFG_CMD_ELF	)
#define CONFIG_BOOTP_MASK	CONFIG_BOOTP_ALL
#include <cmd_confdefs.h>

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP				/* undef to save memory	     */
#define CFG_PROMPT		"# "		/* Monitor Command Prompt    */
#define CFG_CBSIZE		256		/* Console I/O Buffer Size   */
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)  /* Print Buffer Size */
#define CFG_MAXARGS		16		/* max number of command args*/

#define CFG_MALLOC_LEN		128*1024

#define CFG_BOOTPARAMS_LEN	128*1024

#define CFG_HZ			(CPU_TCLOCK_RATE/4)

#define CFG_SDRAM_BASE		0x80000000

#define CFG_LOAD_ADDR		0x80400000	/* default load address */

#define CFG_MEMTEST_START	0x80000000
#define CFG_MEMTEST_END		0x81F70000
/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks */
#define CFG_MAX_FLASH_SECT	(142)	/* max number of sectors on one chip */

#define PHYS_FLASH_1		0xbf000000 /* Flash Bank #1 */	/* MK */

#define CFG_JFFS_CUSTOM_PART	1
#define __SIZE_TYPE__		unsigned int
/* The following #defines are needed to get flash environment right */
#define CFG_MONITOR_BASE	TEXT_BASE
#define CFG_MONITOR_LEN		(256 << 10)

#define CFG_INIT_SP_OFFSET	0x400000

#define CFG_FLASH_BASE		PHYS_FLASH_1

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT	(5 * CFG_HZ) /* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT	(2 * CFG_HZ) /* Timeout for Flash Write */

#define CFG_ENV_IS_IN_FLASH	1

/* Address and size of Primary Environment Sector	*/
#define CFG_ENV_ADDR		0xBFFFC000
#define CFG_ENV_SIZE		0x4000

#define CFG_DIRECT_FLASH_TFTP

#define CONFIG_NR_DRAM_BANKS	1

/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_DCACHE_SIZE		16384
#define CFG_ICACHE_SIZE		16384
#define CFG_CACHELINE_SIZE	16

/*-----------------------------------------------------------------------
 * Serial Configuration
 */
#define CFG_NS16550
#define CFG_NS16550_SERIAL
#define CFG_NS16550_REG_SIZE	 1
#define CFG_NS16550_CLK		 18432000
#define CFG_NS16550_COM1	 0xaf000800

/*-----------------------------------------------------------------------
 * PCI stuff
 */
#define CONFIG_PCI
#define CONFIG_PCI_PNP
#define CONFIG_NET_MULTI
#define CONFIG_EEPRO100
#define CFG_RX_ETH_BUFFER	8		/* use 8 rx buffer on eepro100	*/

#define CONFIG_RTL8139

#endif	/* __CONFIG_H */
